#ifndef _CFF_DICT_H_
#define _CFF_DICT_H_

#include "cff_types.h"
#include "cff.h"

#define CFF_CIDCOUNT_DEFAULT 8720

extern cff_dict *cff_new_dict (void);
extern void      cff_release_dict (cff_dict *dict);

extern void   cff_dict_set (cff_dict *dict, char *key, int idx, double value);
extern double cff_dict_get (cff_dict *dict, char *key, int idx);
extern void   cff_dict_add (cff_dict *dict, char *key, int count);
extern void   cff_dict_remove (cff_dict *dict, char *key);
extern int    cff_dict_known (cff_dict *dict, char *key);

/* decode/encode DICT */
extern cff_dict *cff_dict_unpack (card8 *data, card8 *endptr);
extern long      cff_dict_pack (cff_dict *dict, card8 *dest, long destlen);

#endif /* _CFF_DICT_H_ */
