## miktex.mak: dvipdfm
## Copyright (C) 2001 Christian Schenk <cs@miktex.org>
## 
## This file is part of dvipdfm.
## 
## dvipdfm is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
## 
## dvipdfm is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with dvipdfm; if not, write to the Free Software Foundation,
## 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

!include ..\miktex.inc

mapfiles = t1fonts.map psbase14.map lw35urwa.map lw35urw.map cmr.map
encfiles = ot1alt.enc ot1.enc ot1r.enc
configfiles = config

basedir = $(prefix)\dvipdfm\base
configdir = $(prefix)\dvipdfm\config

objects =	\
		$(outdir)\colorsp.obj \
		$(outdir)\dvi.obj \
		$(outdir)\dvipdfm.obj \
		$(outdir)\encodings.obj \
		$(outdir)\epdf.obj \
		$(outdir)\htex.obj \
		$(outdir)\jpeg.obj \
		$(outdir)\mem.obj \
		$(outdir)\mfileio.obj \
		$(outdir)\mpost.obj \
		$(outdir)\numbers.obj \
		$(outdir)\pdfdev.obj \
		$(outdir)\pdfdoc.obj \
		$(outdir)\pdfobj.obj \
		$(outdir)\pdfparse.obj \
		$(outdir)\pdfspecial.obj \
		$(outdir)\pkfont.obj \
		$(outdir)\pngimage.obj \
		$(outdir)\psimage.obj \
		$(outdir)\psspecial.obj \
		$(outdir)\t1crypt.obj \
		$(outdir)\tfm.obj \
		$(outdir)\ttf.obj \
		$(outdir)\thumbnail.obj \
		$(outdir)\tpic.obj \
		$(outdir)\type1.obj \
		$(outdir)\vf.obj \
		$(outdir)\cff.obj \
		$(outdir)\cff_dict.obj \
		$(outdir)\cid.obj \
		$(outdir)\cidbase.obj \
		$(outdir)\cidtype0.obj \
		$(outdir)\cidtype2.obj \
		$(outdir)\cmap.obj \
		$(outdir)\cs_type2.obj \
		$(outdir)\ps_parse.obj \
		$(outdir)\sfnt.obj \
		$(outdir)\tt_aux.obj \
		$(outdir)\tt_build.obj \
		$(outdir)\tt_cmap.obj \
		$(outdir)\tt_gsub.obj \
		$(outdir)\tt_table.obj \
		$(outdir)\type0.obj \
		$(outdir)\subfont.obj \

ebb_objects = 	\
		$(outdir)\ebb.obj \
		$(outdir)\jpeg.obj \
		$(outdir)\mem.obj \
		$(outdir)\mfileio.obj \
		$(outdir)\numbers.obj \
		$(outdir)\pdfobj.obj \
		$(outdir)\pdfparse.obj \
		$(outdir)\pngimage.obj \

sources =	\
		colorsp.c \
		dvi.c \
		dvipdfm.c \
		dvipdft.cpp \
		ebb.c \
		encodings.c \
		epdf.c \
		htex.c \
		jpeg.c \
		mem.c \
		mfileio.c \
		mpost.c \
		numbers.c \
		pdfdev.c \
		pdfdoc.c \
		pdfobj.c \
		pdfparse.c \
		pdfspecial.c \
		pkfont.c \
		pngimage.c \
		psimage.c \
		psspecial.c \
		t1crypt.c \
		tfm.c \
		ttf.c \
		thumbnail.c \
		tpic.c \
		type1.c \
		vf.c \
		cff.c \
		cff_dict.c \
		cid.c \
		cidbase.c \
		cidtype0.c \
		cidtype2.c \
		cmap.c \
		cs_type2.c \
		ps_parse.c \
		sfnt.c \
		tt_aux.c \
		tt_build.c \
		tt_cmap.c \
		tt_gsub.c \
		tt_table.c \
		type0.c \
		subfont.c \

cc_options = $(cflags) $(cdebug) $(cvarsdll) $(cflagspackfunc) \
		 -I. -I$(libdir) -I$(gnulibdir) -I$(kpslibdir) -I$(pnglibdir) \
		$(miktexvars) -DUSE_MIKTEX_EXIT -I$(zlibdir) -DHAVE_BASENAME

.c{$(outdir)\}.obj:
!ifdef xxx
	$(sed) -e "s/^static \(.*\)(/\1(/" $< > _xyz.c
	$(cc) $(cc_options) -Fo$@ _xyz.c
	del _xyz.c
!else
	$(cc) $(cc_options) -Fo$(outdir)\ $<
!endif

.cpp{$(outdir)\}.obj:
	$(cc) $(cc_options) $(cflagseh) -Fo$(outdir)\ $<

binaries = $(outdir)\dvipdfm.exe $(outdir)\ebb.exe $(outdir)\dvipdft.exe

all: common-all $(binaries)

install: common-install install-binaries $(mapfiles) $(encfiles) $(configfiles) \
		$(basedir) $(configdir)
	for %f in ($(mapfiles)) do copy %f $(basedir)
	for %f in ($(encfiles)) do copy %f $(basedir)
	for %f in ($(configfiles)) do copy %f $(configdir)
#	cd doc & $(MAKE) -f $(miktex_mak) $@ & cd ..

$(basedir):
	$(mkpath) $(basedir)

$(configdir):
	$(mkpath) $(configdir)

qrt: common-qrt

# -----------------------------------------------------------------------------
# dvipdfm
# -----------------------------------------------------------------------------

$(outdir)\dvipdfm.exe: $(outdir) $(objects) $(outdir)\dvipdfm.res \
		$(miktex_lib) $(gnu_lib) $(kps_lib) $(zlib_lib) $(png_lib) dvipdfm.prf
	$(link) $(conlflags) $(ldebug) \
#		-order:@dvipdfm.prf \
		-out:$@ \
		$(objects) $(outdir)\dvipdfm.res \
		$(gnu_lib) $(miktex_lib) $(kps_lib) $(zlib_lib) $(png_lib) \
		$(conlibsdll)

$(outdir)\dvipdfm.res: $(outdir) dvipdfm.rc
	$(rc) $(rcflags) $(rcvars) -I$(libdir) -Fo$@ dvipdfm.rc

# -----------------------------------------------------------------------------
# ebb
# -----------------------------------------------------------------------------

ebb_req = $(ebb_objects) $(outdir)\ebb.res $(miktex_lib) $(kps_lib) \
		$(gnu_lib) $(zlib_lib) $(png_lib)

$(outdir)\ebb.exe: $(outdir) $(ebb_req)
	$(link) $(conlflags) $(ldebug) -out:$@ $(ebb_req) $(conlibsdll)

$(outdir)\ebb.res: $(outdir) ebb.rc
	$(rc) $(rcflags) $(rcvars) -I$(libdir) -Fo$@ ebb.rc

# -----------------------------------------------------------------------------
# dvipdft
# -----------------------------------------------------------------------------

dvipdft_req = $(outdir)\dvipdft.obj $(outdir)\dvipdft.res $(miktex_lib) $(kps_lib)

$(outdir)\dvipdft.exe: $(outdir) $(dvipdft_req)
	$(link) $(conlflags) $(ldebug) -out:$@ $(dvipdft_req) $(conlibsdll)

$(outdir)\dvipdft.res: $(outdir) dvipdft.rc
	$(rc) $(rcflags) $(rcvars) -I$(libdir) -Fo$@ dvipdft.rc

# -----------------------------------------------------------------------------
# clean-up
# -----------------------------------------------------------------------------

mostlyclean: common-mostlyclean
#	cd doc & $(MAKE) -f $(miktex_mak) $@ & cd ..

clean: common-clean mostlyclean
#	cd doc & $(MAKE) -f $(miktex_mak) $@ & cd ..

distclean: common-distclean clean
#	cd doc & $(MAKE) -f $(miktex_mak) $@ & cd ..

realclean: common-realclean distclean
#	cd doc & $(MAKE) -f $(miktex_mak) $@ & cd ..

# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------

!include ..\common-dependencies.inc

depend: $(sources)
	$(MAKEDEPEND1) -I..\zlib -I..\libkps -DHAVE_BASENAME -DHAVE_ZLIB $**

# DO NOT DELETE

$(outdir)\colorsp.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\colorsp.obj: ..\libkps\web2c-miktex.h mem.h pdfdev.h numbers.h
$(outdir)\colorsp.obj: pdfobj.h pdfparse.h pdfspecial.h dvipdfm.h
$(outdir)\dvi.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\dvi.obj: ..\libkps\web2c-miktex.h mem.h error.h mfileio.h numbers.h
$(outdir)\dvi.obj: dvi.h pdfdev.h pdfobj.h dvicodes.h pdflimits.h pdfdoc.h
$(outdir)\dvi.obj: tfm.h vf.h
$(outdir)\dvipdfm.obj: config.h system.h ..\lib\miktex.h
$(outdir)\dvipdfm.obj: ..\libgnu\gnu-miktex.h ..\libkps\web2c-miktex.h mem.h
$(outdir)\dvipdfm.obj: mfileio.h numbers.h dvi.h error.h pdfdev.h pdfobj.h
$(outdir)\dvipdfm.obj: pdfdoc.h encodings.h type1.h ttf.h colorsp.h
$(outdir)\dvipdfm.obj: pdfparse.h pdfspecial.h vf.h pkfont.h thumbnail.h
$(outdir)\dvipdfm.obj: psimage.h tfm.h
$(outdir)\dvipdft.obj: ..\lib\miktex.h
$(outdir)\ebb.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\ebb.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h
$(outdir)\ebb.obj: pdfobj.h jpeg.h pdfspecial.h pdfparse.h config.h
$(outdir)\ebb.obj: pngimage.h
$(outdir)\encodings.obj: pdflimits.h pdfobj.h mem.h error.h system.h
$(outdir)\encodings.obj: ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\encodings.obj: ..\libkps\web2c-miktex.h mfileio.h numbers.h
$(outdir)\encodings.obj: pdfparse.h encodings.h winansi.h
$(outdir)\epdf.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\epdf.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h
$(outdir)\epdf.obj: pdfobj.h pdfdoc.h pdfspecial.h epdf.h
$(outdir)\htex.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\htex.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h dvi.h
$(outdir)\htex.obj: error.h pdfdev.h pdfobj.h htex.h pdfparse.h pdfdoc.h
$(outdir)\jpeg.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\jpeg.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h dvi.h
$(outdir)\jpeg.obj: error.h pdfdev.h pdfobj.h jpeg.h pdfspecial.h
$(outdir)\mem.obj: mem.h
$(outdir)\mfileio.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\mfileio.obj: ..\libkps\web2c-miktex.h mfileio.h numbers.h error.h
$(outdir)\mpost.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\mpost.obj: ..\libkps\web2c-miktex.h mem.h error.h mfileio.h
$(outdir)\mpost.obj: numbers.h dvi.h pdfdev.h pdfobj.h pdfspecial.h
$(outdir)\mpost.obj: pdfparse.h mpost.h pdflimits.h pdfdoc.h
$(outdir)\numbers.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\numbers.obj: ..\libkps\web2c-miktex.h error.h mfileio.h numbers.h
$(outdir)\pdfdev.obj: config.h system.h ..\lib\miktex.h
$(outdir)\pdfdev.obj: ..\libgnu\gnu-miktex.h ..\libkps\web2c-miktex.h mem.h
$(outdir)\pdfdev.obj: error.h mfileio.h numbers.h dvi.h pdfdev.h pdfobj.h
$(outdir)\pdfdev.obj: tfm.h pdfdoc.h type1.h ttf.h pkfont.h pdfspecial.h
$(outdir)\pdfdev.obj: pdfparse.h tpic.h htex.h mpost.h psspecial.h colorsp.h
$(outdir)\pdfdev.obj: pdflimits.h twiddle.h encodings.h colors.h
$(outdir)\pdfdoc.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pdfdoc.obj: ..\libkps\web2c-miktex.h config.h mem.h error.h
$(outdir)\pdfdoc.obj: mfileio.h numbers.h dvi.h pdfdev.h pdfobj.h pdflimits.h
$(outdir)\pdfdoc.obj: pdfdoc.h pdfspecial.h thumbnail.h
$(outdir)\pdfobj.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pdfobj.obj: ..\libkps\web2c-miktex.h config.h mem.h error.h
$(outdir)\pdfobj.obj: mfileio.h numbers.h pdflimits.h pdfobj.h pdfspecial.h
$(outdir)\pdfobj.obj: pdfparse.h twiddle.h ..\zlib\zlib.h ..\zlib\zconf.h
$(outdir)\pdfparse.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pdfparse.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h
$(outdir)\pdfparse.obj: dvi.h error.h pdfdev.h pdfobj.h pdfparse.h
$(outdir)\pdfparse.obj: pdfspecial.h pdfdoc.h
$(outdir)\pdfspecial.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pdfspecial.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h
$(outdir)\pdfspecial.obj: dvi.h error.h pdfdev.h pdfobj.h pdflimits.h
$(outdir)\pdfspecial.obj: pdfspecial.h pdfdoc.h pdfparse.h jpeg.h epdf.h
$(outdir)\pdfspecial.obj: mpost.h psimage.h config.h pngimage.h
$(outdir)\pkfont.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pkfont.obj: ..\libkps\web2c-miktex.h mem.h error.h mfileio.h
$(outdir)\pkfont.obj: numbers.h pkfont.h pdfobj.h pdflimits.h tfm.h
$(outdir)\pngimage.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\pngimage.obj: ..\libkps\web2c-miktex.h config.h mem.h pdfobj.h
$(outdir)\psimage.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\psimage.obj: ..\libkps\web2c-miktex.h config.h mem.h mfileio.h
$(outdir)\psimage.obj: numbers.h pdfobj.h psimage.h pdfspecial.h epdf.h
$(outdir)\psspecial.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\psspecial.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h
$(outdir)\psspecial.obj: psspecial.h pdfparse.h pdfobj.h pdfspecial.h
$(outdir)\psspecial.obj: psimage.h mpost.h pdfdoc.h
$(outdir)\t1crypt.obj: t1crypt.h
$(outdir)\tfm.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\tfm.obj: ..\libkps\web2c-miktex.h mem.h error.h mfileio.h numbers.h
$(outdir)\tfm.obj: pdflimits.h tfm.h config.h
$(outdir)\ttf.obj: config.h ttf.h pdfobj.h system.h ..\lib\miktex.h
$(outdir)\ttf.obj: ..\libgnu\gnu-miktex.h ..\libkps\web2c-miktex.h mem.h
$(outdir)\ttf.obj: error.h mfileio.h numbers.h tfm.h pdflimits.h twiddle.h
$(outdir)\ttf.obj: encodings.h macglyphs.h
$(outdir)\thumbnail.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\thumbnail.obj: ..\libkps\web2c-miktex.h config.h mfileio.h
$(outdir)\thumbnail.obj: numbers.h mem.h pdfobj.h thumbnail.h pngimage.h
$(outdir)\tpic.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\tpic.obj: ..\libkps\web2c-miktex.h mem.h mfileio.h numbers.h tpic.h
$(outdir)\tpic.obj: pdfparse.h pdfobj.h pdfdoc.h dvi.h error.h pdfdev.h
$(outdir)\type1.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\type1.obj: ..\libkps\web2c-miktex.h mem.h error.h mfileio.h
$(outdir)\type1.obj: numbers.h pdfobj.h type1.h tfm.h pdfparse.h pdflimits.h
$(outdir)\type1.obj: t1crypt.h twiddle.h encodings.h standardenc.h
$(outdir)\vf.obj: system.h ..\lib\miktex.h ..\libgnu\gnu-miktex.h
$(outdir)\vf.obj: ..\libkps\web2c-miktex.h mfileio.h numbers.h pdflimits.h
$(outdir)\vf.obj: mem.h error.h tfm.h pdfdev.h pdfobj.h dvi.h vf.h config.h
$(outdir)\vf.obj: dvicodes.h
